Uco.Ingenieria.Software.UI/Controllers/CategoriasController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Uco.Ingeniera.Software.Entidades;
using Uco.Ingeniera.Software.Entidades.Contratos;

namespace Uco.Ingenieria.Software.UI.Controllers
{
    public class CategoriasController : Controller
    {
        public ICategoriasRepositorio CatergoriasRepositorio;
        public CategoriasController(
            ICategoriasRepositorio interfazCategoriasRepositorio)
        {
            this.CatergoriasRepositorio = interfazCategoriasRepositorio;
        }

        [HttpGet]
        public JsonResult ListarCategorias()
        {
            IEnumerable<Categoria> listaCategorias = this.CatergoriasRepositorio.ListaCategorias();
            List<object> listaCategoriasJson = new List<object>();

            listaCategorias.ToList().ForEach(c => listaCategoriasJson.Add(new
                 string[]{
                    c.Id.ToString(),
                    c.Nombre,
                    }));

            return this.Json(listaCategoriasJson, JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult CrearCategoria(string nombre)
        {
            Categoria nuevaCategoria = new Categoria { Nombre = nombre, Id = Guid.NewGuid() };

            var resultado = this.CatergoriasRepositorio.CrearCategoria(nuevaCategoria);

            return this.Json(resultado, JsonRequestBehavior.AllowGet);
        }
    }
}

Uco.Ingenieria.Software.UI/Controllers/ComprasController.cs
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Uco.Ingeniera.Software.Entidades;
using Uco.Ingeniera.Software.Entidades.Contratos;
using Uco.Ingenieria.Software.Utilidades;
using Uco.Ingenieria.Software.Utilidades.Modelos;

namespace Uco.Ingenieria.Software.UI.Controllers
{
    public class ComprasController : Controller
    {
        public IComprasRepositorio ComprasRepositorio;

        public IProductosRepositorio ProductosRepositorio;
        public IGeneradorReporte GeneradorReporte;
        public ComprasController(
            IComprasRepositorio interfazComprasRepositorio,
            IProductosRepositorio interfazProductoRepositorio)
        {
            ComprasRepositorio = interfazComprasRepositorio;
            ProductosRepositorio = interfazProductoRepositorio;
        }

        public ActionResult ListarVentas()
        {
            return View();
        }

        [HttpPost]
        public JsonResult RegistrarVenta(
            IEnumerable<ProductosPorVenta> listaProductos, int idComprador, decimal subTotal, 
            decimal iva, decimal total)
        {
            Random random = new Random();
            int consecutivo = random.Next();
            Guid idVenta = Guid.NewGuid();
            this.ComprasRepositorio.RegistrarVenta(idVenta, listaProductos, idComprador, consecutivo, subTotal, iva, total);

            return Json(idVenta, JsonRequestBehavior.AllowGet);
        }

        public FileResult GenerarEnviarPDF(string consecutivo)
        {
            FileResult resultado = null;
            try
            {
                Venta venta = this.ComprasRepositorio.ConsultarVenta(new Guid(consecutivo));
                IEnumerable<ProductosPorVenta> listaProductos = this.ProductosRepositorio.ListarProductosPorVenta(venta.Id);
                ConfiguracionReporte configuracion = new ConfiguracionReporte();

                configuracion.RutaReporte = Path.Combine(Server.MapPath("~/Reportes"), "FacturaVenta.rdlc");
                configuracion.FormatoReporte = FormatosReporte.PDF;

                List<DataSetReporte> dataSets = new List<DataSetReporte>();
                dataSets.Add(new DataSetReporte { Nombre = "VentaDS", Datos = new List<Venta>() { venta } });
                dataSets.Add(new DataSetReporte { Nombre = "ProductosPorVentaDS", Datos = listaProductos });

                configuracion.DataSets = dataSets;

                List<ParametroReporte> parametros = new List<ParametroReporte>();
                parametros.Add(new ParametroReporte { Nombre = "IdCliente", Valor = venta.IdComprador.ToString() });

                configuracion.ParametrosReporte = parametros;

                configuracion.Pagina = new ConfiguracionPagina { Alto = "11in", Ancho = "8.5", MargenSuperior = "0in", MargenIzquierdo = "0.25in", MargenDerecho = "0.25in", MargenInferior = "0in" };

                byte[] renderedBytes;
                string mimeType = "";

                renderedBytes = this.GeneradorReporte.GenerarReporte(configuracion, out mimeType);

                FileResult archivo = File(renderedBytes, mimeType);
                Session["ExportarFactura"] = archivo;

                resultado = archivo;
            }
            catch (Exception ex)
            {
            }

            return resultado;
        }

        [HttpPost]
        public JsonResult ListarTodasLasVentas()
        {
            IEnumerable<Venta> listaVentas = this.ComprasRepositorio.ListaVentas();

            return this.ConvertirVentasJsonRepositorio(listaVentas);
        }

        private JsonResult ConvertirVentasJsonRepositorio(IEnumerable<Venta> listaVentas)
        {
            List<object> listaVentasJson = new List<object>();

            listaVentas.ToList().ForEach(v => listaVentasJson.Add(new
            {
                consecutivo = v.Consecutivo,
                idComprador = v.IdComprador == null ? "Sin Registro" : v.IdComprador.Value.ToString(),
                fecha = v.Fecha.ToString("yyyy/MM/dd", DateTimeFormatInfo.InvariantInfo),
                subTotal = string.Format(CultureInfo.InvariantCulture, "{0:" + Constantes.FORMATO_DECIMAL + "}", v.SubTotalCompra),
                iva = string.Format(CultureInfo.InvariantCulture, "{0:" + Constantes.FORMATO_DECIMAL + "}", v.IvaCompra),
                total = string.Format(CultureInfo.InvariantCulture, "{0:" + Constantes.FORMATO_DECIMAL + "}", v.TotalCompra),
            }));

            return this.Json(listaVentasJson, JsonRequestBehavior.AllowGet);
        }
    }
}

Uco.Ingenieria.Software.UI/Controllers/ProductosController.cs
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Uco.Ingeniera.Software.Entidades;
using Uco.Ingeniera.Software.Entidades.Contratos;
using Uco.Ingenieria.Software.Utilidades;

namespace Uco.Ingenieria.Software.UI.Controllers
{
    public class ProductosController : Controller
    {
        public IProductosRepositorio ProductosRepositorio;
        public IProveedoresRepositorio ProveedoresRepositorio;
        public ICategoriasRepositorio CatergoriasRepositorio;

        public ProductosController(
            IProductosRepositorio interfazProductosRepositorio,
            IProveedoresRepositorio interfazProveedoresRepositorio,
            ICategoriasRepositorio interfazCategoriasRepositorio)
        {
            this.ProductosRepositorio = interfazProductosRepositorio;
            this.CatergoriasRepositorio = interfazCategoriasRepositorio;
            this.ProveedoresRepositorio = interfazProveedoresRepositorio;
        }

        public ActionResult RealizarCompra()
        {
            return View();
        }

        public ActionResult IngresarProducto()
        {
            return View();
        }

        [HttpGet]
        public JsonResult AutocompletadorProducto(string termino)
        {
            IEnumerable<Producto> listaProductos = this.ProductosRepositorio.AutocompleteProductos(termino);

            return this.ConvertirListaProductosJson(listaProductos);
        }

        private JsonResult ConvertirListaProductosJson(IEnumerable<Producto> listaProductos)
        {
            List<object> listaProductosJson = new List<object>();
            listaProductos.ToList().ForEach(p => listaProductosJson.Add(new
            {
                id = p.Id,
                label = p.Nombre,
                iva = string.Format(CultureInfo.InvariantCulture, "{0:" + Constantes.FORMATO_DECIMAL + "}", p.PrecioSinIva),
                precioTotal = string.Format(CultureInfo.InvariantCulture, "{0:" + Constantes.FORMATO_DECIMAL + "}", p.PrecioDeVenta)
            }));

            return this.Json(listaProductosJson, JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult ListarTodosLosProductos()
        {
            IEnumerable<Producto> listaProductos = this.ProductosRepositorio.ListarProductos();

            return this.ConvertirListaTodosLosProductosJson(listaProductos);
        }

        private JsonResult ConvertirListaTodosLosProductosJson(IEnumerable<Producto> listaProductos)
        {
            List<object> listaProductosJson = new List<object>();
            listaProductos.ToList().ForEach(p => listaProductosJson.Add(new
            {
                id = p.Id,
                nombre = p.Nombre,
                cantidad = p.CantidadDisponible,
                categoria = this.CatergoriasRepositorio.ConsultarCategoria(p.IdCategoria).Nombre,
                proveedor = this.ProveedoresRepositorio.ConsultarProveedor(p.IdProveedor).RazonSocial,
                iva = string.Format(CultureInfo.InvariantCulture, "{0:" + Constantes.FORMATO_DECIMAL + "}", p.PrecioSinIva),
                precioVenta = string.Format(CultureInfo.InvariantCulture, "{0:" + Constantes.FORMATO_DECIMAL + "}", p.PrecioDeVenta),
                precioCompra = string.Format(CultureInfo.InvariantCulture, "{0:" + Constantes.FORMATO_DECIMAL + "}", p.PrecioDeCompra)
            }));

            return this.Json(listaProductosJson, JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult IngresarProducto(Producto producto)
        {
            producto.Id = Guid.NewGuid();

            var resultado = this.ProductosRepositorio.AgregarProducto(producto);

            return this.Json(resultado, JsonRequestBehavior.AllowGet);
        }
    }
}

Uco.Ingenieria.Software.UI/Controllers/ProveedoresController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Uco.Ingeniera.Software.Entidades;
using Uco.Ingeniera.Software.Entidades.Contratos;

namespace Uco.Ingenieria.Software.UI.Controllers
{
    public class ProveedoresController : Controller
    {
        public IProveedoresRepositorio ProveedoresRepositorio;

        public ProveedoresController(
            IProveedoresRepositorio interfazProveedoresRepositorio)
        {
            this.ProveedoresRepositorio = interfazProveedoresRepositorio;
        }

        public ActionResult Proveedores()
        {
            return View();
        }

        [HttpGet]
        public JsonResult AutocompletadorProveedores(string termino)
        {
            IEnumerable<Proveedor> listaProveedores = this.ProveedoresRepositorio.AutocompleteProveedores(termino);

            return this.ConvertirListaProveedoresJson(listaProveedores);
        }

        private JsonResult ConvertirListaProveedoresJson(IEnumerable<Proveedor> listaProveedores)
        {
            List<object> listaProveedoresJson = new List<object>();
            listaProveedores.ToList().ForEach(p => listaProveedoresJson.Add(new
            {
                id = p.Id,
                label = p.RazonSocial
            }));

            return this.Json(listaProveedoresJson, JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult CrearProveedor(Proveedor nuevoProveedor)
        {
           nuevoProveedor.Id = Guid.NewGuid();

            var resultado = this.ProveedoresRepositorio.IngresarProveedor(nuevoProveedor);

            return this.Json(resultado, JsonRequestBehavior.AllowGet);
        }

    }
}

Uco.Ingenieria.Software.UI/Views/Productos/IngresarProducto.cshtml
@{
    ViewBag.Title = "IngresarProducto";
}

<script>
    var urlListarProductos = '@Url.Action("ListarTodosLosProductos", "Productos")';
    var urlListarCategorias = '@Url.Action("ListarCategorias", "Categorias")';
    var urlIngresarProducto = '@Url.Action("IngresarProducto", "Productos")';
    var listarVentas = false;
    var listarProductos = true;
</script>

<section id="portfolio">
    <div class="container">
        <div class="row">
            <div class="col-lg-12 text-center">
                <h2>Ingresar Producto</h2>
                <hr class="star-primary">
            </div>
        </div>
        <div class="row">
            <div class="col-md-3">
                <label for="nombreProducto" style="margin-top:5px">Nombre Producto: </label>
                <input id="nombreProducto" class="form-control" style="margin-left:5px" />
            </div>
            <div class="col-md-3">
                <label for="autocompleteProveedor" style="margin-top:5px">Proveedor: </label>
                <input class="autocomplete-with-hidden form-control ui-autocomplete-input" id="autocompleteProveedor" required="required" type="text" value="" data-url="@Url.Action("AutocompletadorProveedores", "Proveedores")" autocomplete="off" placeholder="Razón social del proveedor." style="max-width:98%">
                <input class="form-control" id="idProveedor" style="display:none;" />
            </div>
            <div class="col-md-3">
                <label for="selectCategoria" style="margin-top:5px">Nombre Producto: </label>
                <select class="form-control" id="selectCategoria"></select>
            </div>
            <div class="col-md-3">
                <label for="cantidadProducto" style="margin-top:5px">Unidades: </label>
                <input id="cantidadProducto" class="form-control" type="number" style="margin-left:5px" />
            </div>
            <div class="col-md-3" style="padding-top:10px">
                <label for="precioCompra" style="margin-top:5px">Precio De Compra: </label>
                <input id="precioCompra" class="form-control" type="number" style="margin-left:5px" />
            </div>
            <div class="col-md-3" style="padding-top:10px">
                <label for="iva" style="margin-top:5px">IVA: </label>
                <input id="iva" class="form-control" type="number" style="margin-left:5px" />
            </div>
            <div class="col-md-3" style="padding-top:10px">
                <label for="precioVenta" style="margin-top:5px">Precio De Venta: </label>
                <input id="precioVenta" class="form-control" type="number" style="margin-left:5px" />
            </div>
            <div class="col-md-3" style="padding-top: 29px;width: auto;padding-left: 50px;">
                <button type="button" class="btn btn-default pull-right btn-lg" onclick="IngresarProducto()">
                    <i class="fa fa-plus-circle"></i> Ingresar Producto
                </button>
            </div>
        </div>
        <div class="row" style="margin-top: 30px">
            <div class="col-lg-12 text-center">
                <h2>Listado Productos</h2>
                <hr class="star-primary">
            </div>
        </div>
        <div class="row">
            <table class="table table-striped" id="tablaProductos" style="width:100%">
                <thead>
                    <tr>
                        <th style="text-align: center;">NOMBRE</th>
                        <th style="text-align: center;">PROVEEDOR</th>
                        <th style="text-align: center;">CANTIDAD DISPONIBLE</th>
                        <th style="text-align: center;">CATEGORIA</th>
                        <th style="text-align: center;">PRECIO DE COMPRA</th>
                        <th style="text-align: center;">IVA</th>
                        <th style="text-align: center">PRECIO DE VENTA</th>
                    </tr>
                </thead>
                <tbody id=""></tbody>
            </table>
        </div>

    </div>
</section>

Uco.Ingenieria.Software.UI/Views/Productos/RealizarCompra.cshtml
@model Uco.Ingeniera.Software.Entidades.Producto
@{
    ViewBag.Title = "Realizar Compra";
}

<script>
    var urlAutocompletadorProducto = '@Url.Action("AutocompletadorProducto", "Productos")';
    var urlRegistrarCompra = '@Url.Action("RegistrarVenta", "Compras")';
    var urlCargarGeneradorPDF = '@Url.Action("GenerarEnviarPDF", "Compras", new { consecutivo = "valor"})';
    var urlGeneradorReporte = '@Url.Action("RegistrarVenta", "Compras")';
    var listarVentas = false;
    var listarProductos = false;
</script>

<section id="portfolio">
    <div class="container">
        <div class="row">
            <div class="col-lg-12 text-center">
                <h2>Crear Compra</h2>
                <hr class="star-primary">
            </div>
        </div>
        <div class="row">
            <div class="col-md-8" style="display:inline-flex">
                <label for="idComprador" style="margin-top:5px">Identificación Comprador: </label>
                <input id="idComprador" class="form-control" style="margin-left:5px" />
            </div>
                <table class="table table-striped" id="tablaProductosCompra" style="width:100%">
                <thead>
                    <tr>
                        <th style="text-align: center; width:30%">DETALLE</th>
                        <th style="text-align: center; width:20%">PRECIO</th>
                        <th style="text-align: center; width:20%">IVA</th>
                        <th style="text-align: center; width:10%">CANTIDAD</th>
                        <th style="text-align: center; width:20%">TOTAL CON IVA</th>
                        <th>
                            <button type="button" title="Agrega producto" id="btnAgregarProducto" class="btn btn-secondary" onclick="AgregarProductoCompra()">
                                <span class='glyphicon glyphicon-plus'></span>
                            </button>
                        </th>
                    </tr>
                </thead>
                <tfoot id="divTotalCompra" style="background-color: #bbc5c5">
                    <tr>
                        <td><label style="font-weight: bold;">SUBTOTAL:</label> </td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td><label id="subtotal" style="font-weight: bold; text-align:right; display:block"></label></td>
                        <td></td>
                    </tr>
                    <tr>
                        <td><label style="font-weight: bold;">IVA:</label> </td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td><label id="totalIva" style="font-weight: bold; text-align:right; display:block"></label></td>
                        <td></td>
                    </tr>
                    <tr>
                        <td><label style="font-weight: bold;">TOTAL:</label> </td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td><label id="totalCompra" style="font-weight: bold; text-align:right; display:block"></label></td>
                        <td></td>
                    </tr>
                </tfoot>
                <tbody id="">
                    <tr>
                        <td>
                            <div class="form-group">
                                <input class="autocomplete-with-hidden form-control ui-autocomplete-input" id="autocompleteProducto1" required="required" type="text" value="" data-url="@Url.Action("AutocompletadorProducto", "Productos")" autocomplete="off" placeholder="Ingrese el nombre del producto." style="max-width:98%">
                                <input class="form-control" id="idProducto1" style="display:none;" />
                            </div>
                        </td>
                        <td><input class="form-control input-sm" id="precioProducto1" style="text-align:right;" disabled /></td>
                        <td><input class='form-control input-sm' id='valorIvaProducto1' style='text-align:right;' disabled /></td>
                        <td><input class='form-control input-sm' id='cantidadPrecio1' onkeyup='CalcularTotalProducto();' /></td>
                        <td><input class='form-control input-sm' id='valorTotalProducto1' style='text-align:right;' disabled/></td>
                        <td>
                            <button type='button' onclick='EliminarProducto(this)' id='btnEliminar1' style='background-color:transparent; border-color:transparent;' title='Elimina el producto seleccionado'>
                                <span class='glyphicon glyphicon-remove'></span>
                            </button>
                        </td>
                    </tr>
                </tbody>
            </table>
            <button type="button" class="btn btn-default pull-right btn-lg" onclick="GenerarCompra()">
                <i class="fa fa-cc-mastercard"></i> Generar Compra
            </button>
        </div>

    </div>
</section>